export declare type Config = {
    angle?: number;
    height?: number;
    ir?: number;
    fixed?: number;
    moveDistance?: number;
    onClick?: (index: number) => void;
    showTooltips?: boolean;
    size?: number;
    showLabels?: boolean;
    showLabelPercentage?: boolean;
    stroke?: string;
    strokeWidth?: number;
    textSize?: number;
    tooltipShowName?: boolean;
    tooltipShowPercentage?: boolean;
    tooltipShowValue?: boolean;
};
export declare type PieConfig = {
    angle: number;
    height: number;
    ir: number;
    fixed: number;
    moveDistance: number;
    onClick: (index: number) => void;
    showTooltips: boolean;
    size: number;
    showLabels: boolean;
    showLabelPercentage: boolean;
    stroke: string;
    strokeWidth: number;
    textSize: number;
    tooltipShowName: boolean;
    tooltipShowPercentage: boolean;
    tooltipShowValue: boolean;
};
export declare type Data = number[] | UserData[];
export declare type UserData = {
    color?: string;
    label?: string;
    value: number;
};
export declare type PieSlice = {
    color: string;
    endAngle: number;
    index: number;
    label?: string;
    moved: boolean;
    percentageValue: number;
    startAngle: number;
    value: number;
    middleAngle: number;
};
export declare type PieSlices = PieSlice[];
export declare type PathType = 'end' | 'inner' | 'outer' | 'start' | 'top';
